<?php


/**
 * @version 23.11.dev
 * @package    Datafeeds for Joomla
 * @author     Bram <bram@brambring.nl>
 * @copyright  2023 Bram Brambring
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

 \defined('_JEXEC') or die('Restricted access');
 
use Joomla\CMS\Factory;
use Joomla\CMS\MVC\Controller\BaseController;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Uri\Uri;

class DatafeedsControllerCron extends BaseController
{
    public $sqls=[];
    public function __construct($config = [])
    {
        parent::__construct($config);
    }
    public function display($cachable = false, $urlparams = false)
    {
        $app=Factory::getApplication();
        $db= Factory::getContainer()->get('DatabaseDriver');
        $input = $app->input;
        // joomla plaatst ook no-cache headers. Waarschijnlijk niet meer nodig
       $app->setHeader("Cache-Control", "no-cache, must-revalidate", true); //HTTP 1.1
       $app->setHeader("Pragma", "no-cache", true); //HTTP 1.0
       $app->setHeader("Expires", "Sat, 26 Jul 1997 05:00:00 GMT", true); // Date in the past



        $nid    = $input->get('nid', '', 'string');
        $freq   = $input->get('freq', 0, 'int');
        HTMLHelper::_('jquery.framework'); ?>
    <div class="row">

<div id="j-main-container" class="span10 col-md-10">
        <?php
        if ($nid) {
            $where[]="feed = '$nid'";
        }

        if ($freq) {
            $where[]="(`last_update` + interval $freq second< now())";
        } else {
            $where[]="(`last_update` + interval `freq` second< now())";
        }
        $where[]='published>0';

        $where_q="where " . join(" and ", $where);
        $query="select feed,feed_id from #__datafeeds $where_q";
        $db->setQuery($query);
        $list = $db->loadAssocList();
        if (count($list) == 0) {
            print "<h1>".Text::_("ALL_UP_TO_DATE")."</h1>";
        } else {
            foreach ($list as $feed) {
                $f=$feed['feed'];
                $c=$feed['feed_id'];
                $div="run_cron_".$c;
                print '<p><a href="index.php?option=com_datafeeds&c=datafeed&task=edit&cid='.$c.'">Edit '.$f.'</a></p>';
                print '<div width="100%" id="'.$div.'" class="run_cron"><h1>'.$f.'</h1></div>';
            }
        }
        $document=  Factory::getDocument();
        if (count($list) > 1) {
            $document->addStyleDeclaration('div.post_cron { height:300px;overflow:auto;}');
        }

        if (! $nid) {
            $f='Clean Up';
            $div="run_cron_cleanup";
            print '<div width="100%" id="'.$div.'" class="run_cron"><h1>'.$f.'</h1></div>';
        } ?>
<p><a href="components/com_datafeeds/cron/feedcron.php" target="_blank">Direct link to cron</a></p>
</div></div>
        <?php
        $url=Uri::BASE().'components/com_datafeeds/cron/feedcron.php';
        $wait='<div id="wave"> <span class="dot"></span> <span class="dot"></span> <span class="dot"></span></div>';
        $text=Text::_("PLEASE_WAIT_THIS_MIGHT_TAKE_A_WHILE");
        $time=time();
        $css = <<<EOM
div#wave {
  position: relative;
  margin: 5px auto;
  text-align: center;
  width: 100px;
  height: auto;
  margin-left: auto;
  margin-right: auto;
}
div#wave .dot {
  display: inline-block;
  width: 12px;
  height: 12px;
  border-radius: 50%;
  margin-right: 3px;
  background-color: #f6b042;
  animation: wave 1.3s linear infinite;
}
div#wave .dot:nth-child(2) {
  animation-delay: -1.1s;
  background-color: #37bc9b;
}
div#wave .dot:nth-child(3) {
  animation-delay: -0.9s;
background-color: #da4453;
}

@-webkit-keyframes wave {
    0% {
        transform: translateY(0)
    }

        100%,30% {
	        transform: translateY(0);
		        opacity: 1
				    }

    45% {
        transform: translateY(-1.5em);
        opacity: .5
    }

    60% {
        transform: translateY(.8em);
        opacity: .95
    }
}

@keyframes wave {
    0% {
        transform: translateY(0)
    }

    100%,30% {
        transform: translateY(0);
        opacity: 1
    }

    45% {
        transform: translateY(-1.5em);
        opacity: .5
    }

    60% {
        transform: translateY(.8em);
        opacity: .95
    }
}

EOM;

        $js = <<<EOM
	jQuery(document).ready( function(){
        nextRequest();
	});
        var wait='<div style="width:100%;text-align:center">$wait<br/>$text<'+'/div>';
	function ScrollToElement(theElement){

  	var selectedPosX = 0;
  	var selectedPosY = 0;

  	while(theElement != null){
    		selectedPosY += theElement.offsetTop;
    		theElement = theElement.offsetParent;
  	}

 	window.scrollTo(selectedPosX,selectedPosY);

}

	function nextRequest() {
		var myElements=jQuery('div.run_cron');
		if ( myElements[0] ) {
			ScrollToElement(myElements[0]);
			cronRequest(myElements[0]);
		}
	}
	function cronRequest(el) {
                        var feed=el.getElementsByTagName('h1')[0].innerHTML;
                        var id=el.id;
			url='$url';
		       el.setAttribute("class","post_cron");el.innerHTML+=wait;
	                new jQuery.ajax({
				url:url,
				success:function(responseText) {el.innerHTML=responseText;
				el.setAttribute("style","font-family:monospace;white-space:pre");
				nextRequest();
				},
				failure:function(responseText) {el.innerHTML=JSON.stringify(responseText)+"<br/>Failed"; nextRequest();},
				error:function(responseText) {el.innerHTML=JSON.stringify(responseText)+"<br/>Error"; nextRequest();},
				data: {
				'cache' : '$time',
				'feed' : feed,
				'freq' : '$freq'
				}
			});

	}
EOM;
        $document->addScriptDeclaration($js);
        $document->addStyleDeclaration($css);
    }
}
