<?php


/**
 * @version 23.11.dev
 * @package    Datafeeds for Joomla
 * @author     Bram <bram@brambring.nl>
 * @copyright  2023 Bram Brambring
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

 \defined('_JEXEC') or die('Restricted access');
 



use Joomla\CMS\Factory;
use Joomla\CMS\MVC\Controller\BaseController;
use Joomla\CMS\Pagination\Pagination;


class DatafeedsControllerOverview extends BaseController
{
    /**
     * constructor (registers additional tasks to methods)
     * @return void
     */
    /**
     * Method to display the view
     *
     * @access  public
     */
    public function display($cachable = false, $urlparams = false)
    {
            $app = Factory::getApplication();
            $db =Factory::getContainer()->get('DatabaseDriver');

            $context     = 'com_datafeed.overview.';
              $lists=[];
              $formData=$app->input->getArray(['filter'=>'','list'=>'']);

              $filter=$formData['filter']??[];

              foreach (['f0','search','feed'] as $field) {
                if ( isset($filter[$field])) {
                  $app->setUserState($context.$field,$filter[$field]);
                } else {
                  $filter[$field]=$app->getUserState($context.$field,  '', 'string');

                }
              }
              $list=$formData['list'];

              if ( isset($list['limit'])) {
                $app->setUserState($context.'limit',$list['limit']);
              } else {
                 $list['limit']=$app->getUserState($context.'limit',  $app->get('list_limit'), 'int');
              }

              if ( isset($list['fullordering'])) {
                $app->setUserState($context.'fullordering',$list['fullordering']);
              } else {
                 $list['fullordering']=$app->getUserState($context.'fullordering',  'feed DESC', 'string');
              }



              $lists['filter']=$filter;
              $lists['list']=$list;
              extract($filter);
              extract($list);
              $limitstart      = $app->getUserStateFromRequest($context.'limitstart', 'limitstart', 0, 'int');
              $where=[];
          if ($f0) {
              $where[] = "field0 = ".$db->Quote($f0);
            }
          if ($feed) {
              $where[] = "feed = ".$db->Quote($feed);
            }
              $where      = count($where) ?' WHERE '.implode(' AND ', $where) : '';
        $query = 'SELECT COUNT(distinct field0,feed)' .' FROM #__dataitems' . $where;
        $db->setQuery($query);
        $total = $db->loadResult();
        $pageNav = new Pagination($total, $limitstart, $limit);
        $query = "SELECT distinct max(Adddate) as date, count(feed) AS count, sum(hits) as hits, feed, field0 as s0,
        count(distinct field1) as s1,
        count(distinct field2) as s2,
        count(distinct field2) as s3
        FROM #__dataitems
         $where
        group by feed,field0
        ORDER BY hits DESC
        LIMIT {$pageNav->limitstart},{$pageNav->limit}";
        $db->setQuery($query);
        $rows=$db->loadObjectList();
          require_once(JPATH_COMPONENT.'/views/overview.php');
        DatafeedssViewoverview::feeds($rows, $pageNav, $lists);
    }
}
