<?php


/**
 * @version 23.11.dev
 * @package    Datafeeds for Joomla
 * @author     Bram <bram@brambring.nl>
 * @copyright  2023 Bram Brambring
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

 \defined('_JEXEC') or die('Restricted access');
 

if (!function_exists('clean_String')) {
    function clean_string($string)
    {
        static $replace = [
            'amp;' => '',
            '
' => '', # ^M
            '`' => "'",
            '´' => "'",
            "\n" => ' ',
            '-' => ' ',
            '/' => ' ',
            ':' => ' ',
            '&' => ' ',
            '"' => ' ',
            '?' => ' ',
            '+' => ' ',
            '#' => ' ',
            '%' => ' ',
            '>' => ' ',
            '<' => ' ',
            ';' => ' '
        ];
        if (is_numeric($string)) {
            return $string;
        }
        $string = strtr($string, $replace);
        $string = trim($string);
        $string = preg_replace("/  */", " ", $string);
        return $string;
    }
}
if (!defined("DF_MAXROWS")) {
    define("DF_MAXROWS", 100);
}
if (!defined("DF_UPDATEQUERY")) {
    define("DF_UPDATEQUERY", "`title` = VALUES(`title`),`status` = VALUES(`status`),`url` = VALUES(`url`),`image` = VALUES(`image`),`description` = VALUES(`description`),`price` = VALUES(`price`),`data` = VALUES(`data`),`feed` = VALUES(`feed`),`field0` = VALUES(`field0`),`field1` = VALUES(`field1`),`field2` = VALUES(`field2`),`field3` = VALUES(`field3`),`field4` = VALUES(`field4`),`field5` = VALUES(`field5`),`field6` = VALUES(`field6`),`field7` = VALUES(`field7`),`field8` = VALUES(`field8`),`field9` = VALUES(`field9`),`field10` = VALUES(`field10`),`field11` = VALUES(`field11`),`field12` = VALUES(`field12`),`field13` = VALUES(`field13`),`field14` = VALUES(`field14`),`field15` = VALUES(`field15`),`field16` = VALUES(`field16`),`field17` = VALUES(`field17`),`field18` = VALUES(`field18`),`field19` = VALUES(`field19`)");
}
if (!defined("DF_INSERTFIELDS")) {
    define("DF_INSERTFIELDS", [
        '`field0`' => '',
        '`field1`' => '',
        '`field2`' => '',
        '`field3`' => '',
        '`field4`' => '',
        '`field5`' => '',
        '`field6`' => '',
        '`field7`' => '',
        '`field8`' => '',
        '`field9`' => '',
        '`field10`' => '',
        '`field11`' => '',
        '`field12`' => '',
        '`field13`' => '',
        '`field14`' => '',
        '`field15`' => '',
        '`field16`' => '',
        '`field17`' => '',
        '`field18`' => '',
        '`field19`' => '',
        '`feed_id`' => 0,
        '`feed`' => '',
        '`title`' => '',
        '`id`' => '',
        '`image`' => '',
        '`description`' => '',
        '`url`' => '',
        '`data`' => '[]',
        '`price`' => 0.0,
        '`status`' => 1,
        '`adddate`' => 'CURRENT_TIMESTAMP'
    ]);
}
function lastitems()
{
    storeitems(true);
}
function storeitems($row)
{
    static $df_inserts = [];
    global $db_table;
    if ($row !== true) {
        $df_inserts[] = $row;
    }
    $c = count($df_inserts);
    if ($c && ($c >= DF_MAXROWS || $row === true)) {
        $insert_string = "(" . join(",", array_keys(DF_INSERTFIELDS)) . ") VALUES " . join(",", $df_inserts);
        $query = "INSERT LOW_PRIORITY INTO `$db_table` $insert_string ON DUPLICATE KEY UPDATE " . DF_UPDATEQUERY;
        db_query($query);
        $df_inserts = [];
    }
}

function storeitem(&$item)
{
    global $feed_opts;
    
    
    #
    #simpel subitem
    if (defined('SPLITKOMMA')) {
        if (!empty($item['field1'])) {
            $select1 = $item['field1'];
            if (strstr($select1, ",")) {
                $selecties = explode(',', $select1);
                $orig_item = $item;
                foreach ($selecties as $select1) {
                    if (isset($item['var'][$select1])) {
                        $item = array_merge($orig_item, $item['var'][$select1]);
                    } else {
                        $item['field1'] = $select1;
                    }
                    unset($item['var']);
                    storeitem($item, false);
                }
                return;
            }
        }
    }

    if (isset($item['var'])) {
        $vars = $item['var'];
        unset($item['var']);
        $orig_item = $item;
        foreach ($vars as $var) {
            $item = array_merge($orig_item, $var);
            if (!empty($item['field1']) && strpos($item['field1'], ",") === false) {
                storeitem($item, false);
            } else {
                print "<h2>ITERATION BLOCKED</h2>";
            }
        }
        return;
    }


    if (empty($item['title'])) {
        return;
    }
    $inserts = DF_INSERTFIELDS;

    for ($i = 0; $i < 20; $i++) {
        $inserts["`field$i`"] = db_real_escape_string(!empty($item["field$i"]) ? clean_string($item["field$i"]) : $inserts["`field$i`"], true);
    }
    $inserts['`feed_id`'] = (int)$feed_opts['feed_id'];
    $inserts['`feed`']   = db_real_escape_string(!empty($item['feed']) ? clean_string($item['feed']) : "'Feed: {$feed_opts['feed_id']}'", true);
    $inserts['`title`']  = db_real_escape_string(!empty($item['title']) ? clean_string($item['title']) : $inserts['`title`'], true);
    $inserts['`id`'] = db_real_escape_string($item['md5'] ?? md5(join("", $inserts)), true);


    $inserts['`image`']  = db_real_escape_string(!empty($item['image']) ? trim($item['image']) : $inserts['`image`'], true);
    $inserts['`description`']  = db_real_escape_string(!empty($item['description']) ? trim($item['description']) : $inserts['`description`'], true);
    $inserts['`url`']  = db_real_escape_string(!empty($item['url']) ? trim($item['url']) : $inserts['`url`'], true);
    $inserts['`data`'] = db_real_escape_string(!empty($item['data']) ? json_encode($item['data']) : $inserts['`data`'], true);



    $p = $item['price'] ?? $inserts['`price`'];
    switch (substr($p, -3, 1)) {
        case '.':
            $p = str_replace(',', '', $p);
            break;
        case ',':
            $p = str_replace(array('.', ','), array('', '.'), $p);
            break;
        default:
            $p = str_replace(',', '', $p);
    }
    $inserts['`price`'] = (float)$p;

    #$insert_string="(".join(",", array_keys($inserts)) .") VALUES (".join(",", array_values($inserts)).")";
    $insert_string = "(" . join(",", array_values($inserts)) . ")";
    storeitems($insert_string);
}

function sql_count()
{
    global $db_table;
    $_cursor = db_query("SELECT count(*) AS `count` FROM $db_table");
    $row = db_fetch_assoc($_cursor);
    StopWatch(__LINE__ . " : END  END {$row['count']} items in database");
}
function pre_clean_up($feed_id)
{
    global $db_table, $tmp_table;
    $col_q = "SELECT COLUMN_TYPE AS `c` FROM INFORMATION_SCHEMA.COLUMNS WHERE `table_name` = '$db_table' AND `COLUMN_NAME` = 'items_id'";
    $_cursor = db_query($col_q);
    $col = db_fetch_assoc($_cursor);
    $column_type = $col['c'];

    StopWatch(__LINE__ . " : START  temp table");
    db_query("UPDATE `$db_table` SET `status`=2 WHERE `status`=1 AND `feed_id`='$feed_id'");
    $result = db_query("SELECT max(`items_id`)+1 AS `h`  FROM `$db_table`");
    $row = db_fetch_assoc($result);
    db_query("DROP TABLE IF EXISTS `$tmp_table`");
    db_query("CREATE TABLE `$tmp_table`  SELECT * FROM $db_table WHERE `feed_id`='$feed_id' ");
    db_query("ALTER TABLE `$tmp_table` ADD UNIQUE(`id`),ADD PRIMARY KEY (`items_id`),CHANGE `items_id` `items_id` $column_type  NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=" . (int)$row['h']);
    StopWatch(__LINE__ .  " : END  temp table");
}
function feed_clean_up($feed_id)
{
    global $db_table, $tmp_table;
    StopWatch(__LINE__ .   " : START post import copy items");
    db_query("DELETE FROM `$tmp_table` WHERE `status` = 2"); #No need to move these
    StopWatch(__LINE__ .  " : START post import move items");
    db_query("INSERT LOW_PRIORITY INTO `$db_table` SELECT * FROM $tmp_table  ON DUPLICATE KEY UPDATE " . DF_UPDATEQUERY, true); # move temp table back
    StopWatch(__LINE__ .  " : START post import purge items");
    db_query("DELETE FROM `$db_table` WHERE  `status` = 2 AND feed_id ='$feed_id'"); # delete old items
    StopWatch(__LINE__ .   " : END Post import purge items");
    sql_count();
}

function clean_up()
{
    global $db_table, $db_feeds, $db_database, $mailfrom;
    StopWatch(__LINE__ .  " : START Cleanup of unpublised feed items");
    sql_count();
    $clean_q = "DELETE FROM `$db_table` WHERE NOT (`feed_id` IN (SELECT `$db_feeds`.`feed_id` FROM `$db_feeds` WHERE `$db_feeds`.`published`>0))";
    $_cursor = db_query($clean_q);
    sql_count();
    StopWatch(__LINE__ .  " : END Cleanup of unpublised feed items");

    if (defined('DF_OPTIMIZE_ALL')) {
        $where = '';
    } else {
        $where = "WHERE `Name`='$db_table';";
    }
    $result = db_query("SHOW TABLE STATUS FROM `$db_database` $where");
    while ($array = db_fetch_assoc($result)) {
        if ($array['Data_free'] > 0) {
            echo
            'Table: ' . $array['Name'] .
                ' Free Size: ' . $array['Data_free'] . "\n";
            if (df_check_load(false)) {
                StopWatch(__LINE__ .  "START Optimize {$array['Name']}");
                db_query("optimize table {$array['Name']}");
                StopWatch(__LINE__ .  "END Optimize {$array['Name']}");
            }
        }
    }

    $col_q = "SELECT DATA_TYPE AS `d` FROM INFORMATION_SCHEMA.COLUMNS WHERE `table_name` = '$db_table' AND COLUMN_NAME = 'items_id'";
    $_cursor = db_query($col_q);
    $col = db_fetch_assoc($_cursor);
    $datatype = strtolower($col['d']); #this are always ascii, no mb_strtolower needed
    switch ($datatype) {
            //http://dev.mysql.com/doc/refman/5.7/en/integer-types.html
        case 'tinyint':
            $max = 255;
            break;
        case 'smallint':
            $max = 65535;
            break;
        case 'int':
            $max = 4294967295;
            break;
        case 'bigint':
            $max = 18446744073709551615;
            break;
        default /*'mediumint'*/:
            $max = 16777215;
    }
    $item_q = "SELECT max(items_id) AS i FROM $db_table";
    $_cursor = db_query($item_q);
    $row = db_fetch_assoc($_cursor);
    if ($row['i'] > 0.95 * $max) { // marge
        StopWatch(__LINE__ . " : START Resetting items_id");
        $alter_q = "ALTER TABLE `$db_table` DROP `items_id`";
        $_cursor = db_query($alter_q);
        $alter_q = "ALTER TABLE `$db_table` ADD `items_id` $datatype UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY FIRST";
        $_cursor = db_query($alter_q);
        StopWatch(__LINE__ . " : END  Resetting items_id");
        mail($mailfrom, "Dataitems items_id reset", "The items id had been reset. Please check depencies like images", "From: " . $mailfrom);
    } else {
        print "Datafeeds items_id {$row['i']}/$max\n";
    }
}
