<?php


/**
 * @version 23.11.dev
 * @package    Datafeeds for Joomla
 * @author     Bram <bram@brambring.nl>
 * @copyright  2023 Bram Brambring
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

 \defined('_JEXEC') or die('Restricted access');
 
global $iso2country;
$iso2country=[];

#iso conversie volgens ISO 3166-1 http://nl.wikipedia.org/wiki/ISO_3166-1
#bij veel gebruik wellicht inkorten door commentaar '#' te plaatsen bij ongebruikte landen
#pas op er zijn feeds die verkeerde codes gebruiken
$iso2country=

[
  'ad' => 'Andorra',
  'ae' => 'Verenigde Arabische Emiraten',
  'af' => 'Afghanistan',
  'ag' => 'Antigua En Barbuda',
  'ai' => 'Anguilla',
  'al' => 'Albanië',
  'am' => 'Armenië',
  'an' => 'Nederlandse Antillen',
  'ao' => 'Angola',
  'aq' => 'Antarctica',
  'ar' => 'Argentinië',
  'as' => 'Amerikaans Samoa',
  'at' => 'Oostenrijk',
  'au' => 'Australië',
  'aw' => 'Aruba',
  'ax' => 'Ålandseilanden',
  'az' => 'Azerbeidzjan',
  'ba' => 'Bosnië En Herzegovina',
  'bb' => 'Barbados',
  'bd' => 'Bangladesh',
  'be' => 'België',
  'bf' => 'Burkina Faso',
  'bg' => 'Bulgarije',
  'bu' => 'Bulgarije',
  'bh' => 'Bahrein',
  'bi' => 'Burundi',
  'bj' => 'Benin',
  'bm' => 'Bermuda',
  'bn' => 'Brunei',
  'bo' => 'Bolivia',
  'bq' => 'Bonaire, Eustatius en Saba',
  'br' => 'Brazilië',
  'bs' => 'Bahama s',
  'bt' => 'Bhutan',
  'bv' => 'Bouvet',
  'bw' => 'Botswana',
  'by' => 'Wit Rusland',
  'bz' => 'Belize',
  'ca' => 'Canada',
  'cc' => 'Cocoseilanden',
  'cd' => 'Congo Kinshasa',
  'cf' => 'Centraal Afrikaanse Republiek',
  'cg' => 'Congo Brazzaville',
  'ch' => 'Zwitserland',
  'ci' => 'Ivoorkust',
  'ck' => 'Cookeilanden',
  'cl' => 'Chili',
  'cm' => 'Kameroen',
  'cn' => 'China',
  'co' => 'Colombia',
  'cr' => 'Costa Rica',
  'cu' => 'Cuba',
  'cw' => 'Curaçao',
  'cv' => 'Kaapverdische Eilanden',
  'cx' => 'Christmaseiland',
  'cy' => 'Cyprus',
  'cz' => 'Tsjechië',
  'de' => 'Duitsland',
  'dj' => 'Djibouti',
  'dk' => 'Denemarken',
  'dm' => 'Dominica',
  'do' => 'Dominicaanse Republiek',
  'dz' => 'Algerije',
  'ec' => 'Ecuador',
  'ee' => 'Estland',
  'eg' => 'Egypte',
  'eh' => 'Westelijke Sahara',
  'er' => 'Eritrea',
  'es' => 'Spanje',
  'sp' => 'Spanje',
  'sx' => 'Sint Maarten',
  'et' => 'Ethiopië',
  'fi' => 'Finland',
  'fj' => 'Fiji',
  'fk' => 'Falklandeilanden',
  'fm' => 'Micronesië',
  'fo' => 'Faeröer',
  'fr' => 'Frankrijk',
  'ga' => 'Gabon',
  'gb' => 'Groot Brittannië',
  'gc' => 'Gran Canaria',
  'uk' => 'Groot Brittannië',
  'gd' => 'Grenada',
  'ge' => 'Georgië',
  'gf' => 'Frans Guyana',
  'gg' => 'Guernsey',
  'gh' => 'Ghana',
  'gi' => 'Gibraltar',
  'gl' => 'Groenland',
  'gm' => 'Gambia',
  'gn' => 'Guinee',
  'gp' => 'Guadeloupe',
  'gq' => 'Equatoriaal Guinea',
  'gr' => 'Griekenland',
  'gs' => 'Zuid Georgië En De Zuidelijke Sandwicheilanden',
  'gt' => 'Guatemala',
  'gu' => 'Guam',
  'gw' => 'Guinee Bissau',
  'gy' => 'Guyana',
  'hk' => 'Hongkong',
  'hm' => 'Heard En McDonaldeilanden',
  'hn' => 'Honduras',
  'hr' => 'Kroatië',
  'ht' => 'Haïti',
  'hu' => 'Hongarije',
  'id' => 'Indonesië',
  'ie' => 'Ierland',
  'il' => 'Israël',
  'im' => 'Isle of Man',
  'in' => 'India',
  'io' => 'Brits Territorium in de Indische Oceaan',
  'iq' => 'Irak',
  'ir' => 'Iran',
  'is' => 'IJsland',
  'it' => 'Italië',
  'je' => 'Jersey',
  'jm' => 'Jamaica',
  'jo' => 'Jordanië',
  'jp' => 'Japan',
  'ke' => 'Kenia',
  'kg' => 'Kirgizië',
  'kh' => 'Cambodja',
  'ki' => 'Kiribati',
  'km' => 'Comoren',
  'kn' => 'Saint Kitts En Nevis',
  'kp' => 'Noord Korea',
  'kr' => 'Zuid Korea',
  'kw' => 'Koeweit',
  'ky' => 'Caymaneilanden',
  'kz' => 'Kazachstan',
  'la' => 'Laos',
  'lb' => 'Libanon',
  'lc' => 'Saint Lucia',
  'li' => 'Liechtenstein',
  'lk' => 'Sri Lanka',
  'lr' => 'Liberia',
  'ls' => 'Lesotho',
  'lt' => 'Litouwen',
  'lu' => 'Luxemburg',
  'lv' => 'Letland',
  'ly' => 'Libië',
  'ma' => 'Marokko',
  'mc' => 'Monaco',
  'me' => 'Montenegro',
  'mg' => 'Madagaskar',
  'mh' => 'Marshalleilanden',
  'mk' => 'Macedonië',
  'ml' => 'Mali',
  'mm' => 'Myanmar',
  'mn' => 'Mongolië',
  'mo' => 'Macau',
  'mp' => 'Noordelijke Marianen',
  'mq' => 'Martinique',
  'mr' => 'Mauritanië',
  'ms' => 'Montserrat',
  'mt' => 'Malta',
  'mu' => 'Mauritius',
  'md' => 'Maldiven',
  'mv' => 'Maldiven',
  'mw' => 'Malawi',
  'mx' => 'Mexico',
  'my' => 'Maleisië',
  'mz' => 'Mozambique',
  'na' => 'Namibië',
  'nc' => 'Nieuw Caledonië',
  'ne' => 'Niger',
  'nf' => 'Norfolk',
  'ng' => 'Nigeria',
  'ni' => 'Nicaragua',
  'nl' => 'Nederland',
  'no' => 'Noorwegen',
  'np' => 'Nepal',
  'nr' => 'Nauru',
  'nu' => 'Niue',
  'nz' => 'Nieuw Zeeland',
  'om' => 'Oman',
  'pa' => 'Panama',
  'pe' => 'Peru',
  'pf' => 'Frans Polynesië',
  'pg' => 'Papoea Nieuw Guinea',
  'ph' => 'Filipijnen',
  'pk' => 'Pakistan',
  'pl' => 'Polen',
  'pm' => 'Saint Pierre En Miquelon',
  'pn' => 'Pitcairneilanden',
  'pr' => 'Puerto Rico',
  'ps' => 'Palestijnse Autoriteit',
  'pt' => 'Portugal',
  'pw' => 'Palau',
  'py' => 'Paraguay',
  'qa' => 'Qatar',
  're' => 'Réunion',
  'ro' => 'Roemenië',
  'rs' => 'Servië',
  'ru' => 'Rusland',
  'rw' => 'Rwanda',
  'sa' => 'Saoedi Arabië',
  'sb' => 'Salomonseilanden',
  'sc' => 'Seychellen',
  'sd' => 'Soedan',
  'se' => 'Zweden',
  'sg' => 'Singapore',
  'sh' => 'Sint Helena',
  'si' => 'Slovenië',
  'sj' => 'Jan Mayen',
  'sk' => 'Slowakije',
  'sl' => 'Sierra Leone',
  'sm' => 'San Marino',
  'sn' => 'Senegal',
  'so' => 'Somalië',
  'sr' => 'Suriname',
  'st' => 'Sao Tomé En Principe',
  'sv' => 'El Salvador',
  'sy' => 'Syrië',
  'sz' => 'Swaziland',
  'tc' => 'Turks  En Caicoseilanden',
  'td' => 'Tsjaad',
  'tf' => 'Franse Zuidelijke En Antarctische Gebieden',
  'tg' => 'Togo',
  'th' => 'Thailand',
  'tj' => 'Tadzjikistan',
  'tk' => 'Tokelau eilanden',
  'tl' => 'Oost Timor',
  'tm' => 'Turkmenistan',
  'tn' => 'Tunesië',
  'to' => 'Tonga',
  'tr' => 'Turkije',
  'tt' => 'Trinidad En Tobago',
  'tv' => 'Tuvalu',
  'tw' => 'Taiwan',
  'tz' => 'Tanzania',
  'ua' => 'Oekraïne',
  'ug' => 'Oeganda',
  'um' => 'Kleine Pacifische eilanden van de Verenigde Staten',
  'us' => 'Verenigde Staten',
  'vs' => 'Verenigde Staten',
  'uy' => 'Uruguay',
  'uz' => 'Oezbekistan',
  'va' => 'Vaticaanstad',
  'vc' => 'Saint Vincent En de Grenadines',
  've' => 'Venezuela',
  'vg' => 'Britse Maagdeneilanden',
  'vi' => 'Amerikaanse Maagdeneilanden',
  'vn' => 'Vietnam',
  'vu' => 'Vanuatu',
  'wf' => 'Wallis En Futuna',
  'ws' => 'Samoa',
  'ye' => 'Jemen',
  'yt' => 'Mayotte',
  'za' => 'Zuid Afrika',
  'zm' => 'Zambia',
  'zw' => 'Zimbabwe',
];


function iso2country($iso)
{
    global $iso2country;
    $m=$iso2country[mb_strtolower($iso)];
    return $m?$m:$iso;
}
