<?php


/**
 * @version 23.11.dev
 * @package    Datafeeds for Joomla
 * @author     Bram <bram@brambring.nl>
 * @copyright  2023 Bram Brambring
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

 \defined('_JEXEC') or die('Restricted access');
 


use Joomla\CMS\Factory;
use Joomla\String\StringHelper;

// Require the base controller
JTable::addIncludePath(JPATH_ADMINISTRATOR.'/components/com_datafeeds/tables');

// Require specific controller if requested
$c=Factory::getApplication()->input->get('c', 'datafeeds');
$t=Factory::getApplication()->input->get('task', 'display');

if (strpos($t, '.')) {
    list($c,$t)=explode('.', $t); #this also catches directory traversal in the '$c'
    Factory::getApplication()->input->set('task', $t);
}

if ($c) {
    require_once(JPATH_COMPONENT.'/controllers/'.$c.'.php');
    $controllerName = 'DatafeedsController'.StringHelper::ucfirst($c);
    $controller = new $controllerName();
    try {
        $controller->execute($t);
    } catch (Exception $e) {
        error_log($e);
    }
    $controller->redirect();
}

if (class_exists('SimpleXMLElement')) {
    $xml_path=JPATH_COMPONENT_ADMINISTRATOR .  '/datafeeds.xml';
    $data = new SimpleXMLElement(file_get_contents($xml_path));
    $version= $data->version   ;
} else {
    $version= '4.0';
}

?>

<style>
ul.sponsorlist {
text-align:center;
background:yellow;
height:34px;
color:#000;
width:95%;
}
ul.sponsorlist li{
color:#000;
font-weight:bold;
float:left;
height:34px;
font-size:12px;
list-style-image:none;
list-style-position:outside;
list-style-type:none;
padding-left:1px;
padding:0 10px;
display:inline;
line-height:30px;
}
</style>
<ul class="offset3 span7 sponsorlist">
<li><a href="https://affiliatefeeds.nl/">Datafeed package <?php echo $version;?></a></li>
<li><a href="https://12l.nl/tradetrack">Tradetracker</a></li>
<li><a href="https://12l.nl/daisycon">Daisycon</a></li>
<li><a href="https://12l.nl/awin">Awin</a></li>
</ul>
