<?php


/**
 * @version 23.11.dev
 * @package    Datafeeds for Joomla
 * @author     Bram <bram@brambring.nl>
 * @copyright  2023 Bram Brambring
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

 \defined('_JEXEC') or die('Restricted access');
 
use Joomla\CMS\Factory;
use Joomla\Filesystem\Path;
use Joomla\Filesystem\Folder;
use Joomla\CMS\Form\Field\ListField;




class JFormFieldComponenttemplates extends ListField
{
    protected $type = 'componenttemplates';

    protected function getOptions()
    {
        #echo $this->getFieldAttribute('attribute','base');
        $db =Factory::getContainer()->get('DatabaseDriver');
        $query = $db->createQuery();
        $query->select('template');
        $query->from('#__template_styles');
        $query->where('client_id = 0');
        $query->where('home = 1');
        $db->setQuery($query);
        $template = $db->loadResult();

        $base =  JPATH_SITE;
        $path1 = $base . '/components/com_datafeeds/views/items/tmpl';
        $path2 = $base . '/templates/' . $template . '/html/com_datafeeds/items';
        $path1 = Path::clean($path1);
        $path2 = Path::clean($path2);
        $options=[];
        $base=(string)$this->element['base'];
        foreach ([$path1,$path2] as $path) {
            if (is_dir($path) && $files = Folder::files($path, $base.'_.*\.php$')) {
                foreach ($files as $f) {
                    $options[$f]=new stdClass();
                    $options[$f]->text = str_replace([$base.'_','.php'], '', $f);
                    $options[$f]->value = $options[$f]->text;
                }
            }
        }

        return $options;
    }
}
