<?php


/**
 * @version 23.11.dev
 * @package    Datafeeds for Joomla
 * @author     Bram <bram@brambring.nl>
 * @copyright  2023 Bram Brambring
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

 \defined('_JEXEC') or die('Restricted access');
 
use Joomla\CMS\Layout\LayoutHelper;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Toolbar\Toolbar;
use Joomla\CMS\Toolbar\ToolbarHelper;
use Joomla\CMS\Form\Form;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Router\Route;


class DatafeedsViewDataitems
{
    public static function display(&$rows, &$pageNav, &$lists)
    {
  HTMLHelper::_('bootstrap.tooltip');
          ToolBarHelper::title(Text::_('COM_DATAFEEDS_ALL_ITEMS'), 'generic.png');
        	Form::addFormPath(JPATH_COMPONENT . '/models/forms');
        	Form::addFieldPath(JPATH_COMPONENT . '/models/fields');
        	$form=new stdClass();
        	$form->filterForm=Form::getInstance('com_datafeeds.filter_dataitems', "filter_dataitems", array('load_data' => false));
          $form->filterForm->bind($lists);
        	$form->activeFilters=$lists;
          $showimage=('1' == ($lists['list']['showimage']??''));
        ?>
<div class="row">
<form id="adminForm" action="<?php echo Route::_('index.php?option=com_datafeeds')?>" method="post" name="adminForm" enctype="multipart/form-data" >
<div class="row">
<div class="col-md-12">
<div id="j-main-container" class="j-main-container">
<?php echo LayoutHelper::render('joomla.searchtools.default', ['view' => $form]); ?>
<div class="clearfix"></div>

        <?php
        echo '<table class="table table-striped"><thead>';
        echo '<tr>';
        # <th width="5%"><input type="checkbox" name="toggle" value=""  onclick="checkAll(';echo count( $rows );echo ');" /></th>';
        if ($showimage) {
            echo '<th width="10%" nowrap="nowrap" class="title">'
            . Text::_('Image')
            . '</th>';
        }
        list($order,$order_Dir)=explode(' ',$lists['list']['fullordering']??'items_id DESC',2);

        echo '<th>'
        . HTMLHelper::_('searchtools.sort',  'TITLE', 'title', $order_Dir, $order);
        echo '</th>';

        echo '<th>'
        . HTMLHelper::_('searchtools.sort',  'PRICE', 'price', $order_Dir, $order);
        echo '</th>';
        echo '<th>'
        . HTMLHelper::_('searchtools.sort',  'MERCHANTFEED', 'feed', $order_Dir, $order);
        echo '</th>';

        echo '<th>'
        . HTMLHelper::_('searchtools.sort',  'FIELD0', 'field0', $order_Dir, $order);
        echo '</th>';

        echo '<th>'
        . HTMLHelper::_('searchtools.sort',  'Hits', 'hits', $order_Dir, $order);
        echo '</th>';

        echo '<th>'
        . HTMLHelper::_('searchtools.sort', 'ADDEDID', 'items_id', $order_Dir, $order);
        echo '</th>';
        echo '</tr></thead><tbody>';
        $k = 0;
         foreach ($rows as $i => $row) {
            $link       = Route::_('index.php?option=com_datafeeds&c=dataitems&task=resethits&id='.$row->items_id);
            echo "<tr class='row".( $i % 2)."'>";
            if ($showimage) {
                echo '<td><img loading="lazy"  src = "'. $row->image. '" style="width:100px"></td>';
            }
            echo '<td><a href="'.$row->url.'">'.$row->title. '</a></td>';
            echo '<td>'.$row->price. '</a></td>';
            echo '<td>'.$row->feed. '</a></td>';
            echo '<td>'.$row->field0. '</a></td>';
            echo '<td><a href="'. $link. '" title="Reset Hits">'. $row->hits. '</a></td>';
            echo '<td>'.$row->items_id. '</a></td>';
            echo '</tr>';
            $k = 1 -$k;
        }

        echo '</tbody></table>'.$pageNav->getListFooter(). '
		<input type="hidden" name="c" value="dataitems">
    <input type="hidden" name="option" value="com_datafeeds">
  <input id="list_fullordering" type="hidden"  name="list[fullordering]" value="'."$order $order_Dir".'"/>

    <input type="hidden" name="task" value="">
    <input type="hidden" name="boxchecked" value="0">
  </div></div></div></form>
		</div> <!-- XX -->
		</div>
';
    }
}
