<?php


/**
 * @version 23.11.dev
 * @package    Datafeeds for Joomla
 * @author     Bram <bram@brambring.nl>
 * @copyright  2023 Bram Brambring
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

 \defined('_JEXEC') or die('Restricted access');
 
use Joomla\CMS\Language\Text;

echo '<div id="com_datafeeds">';

if ($this->pagination) {
    $links = $this->pagination->getPagesLinks();
    echo '<div class="pagination" id="datafeeds_top">'.$links.'</div>';
}
echo '<div class="datafeeds_clear">';
$zebra = 0;
$fields=$this->get('Fields');

$field1 = $fields[1]??'';
$field2 = $fields[2]??'';
$field3 = $fields[3]??'';

$currency=Text::_('DATAFEEDS_CURRENCY');
$more=Text::_('DATAFEEDS_READ_MORE');
$basequery=$this->get('Basequery');

foreach ($this->dataitems as $item) {
    ++$zebra;
    $title=$item['title'];
    $url=$item['url'];
    $image=$item['image'];
    $price = (float)$item['price']; //decimal in database returns as string
    $alt = $title;
        echo '<div class="datafeeds dfzebra'.($zebra % 2).'">
    <h2><a target="_blank" class="dflink" href="'. $url.'" rel="nofollow">'. $title.'</a></h2>
    <div class="datafeeds_description">';
    echo $item['description'];
    if ($price > 0) {
        echo '<p class="price"><span>'.$currency.' '.DatafeedsModelItems::moneyFormat($price).'</span></p>';
    } 
    Echo '<p class="datafeeds_more"><a  class="dflink" href="'.$url.'" target="_blank" rel="nofollow" title="'. $alt.'">'.$more.'</a></p>';

        echo '<span class="datafeeds_bread">';
        if ($s1 = $item[$field1]??'') {
		$basequery['q1']=$s1;
            echo ' <a href="'.DatafeedsModelItems::makeRoute($basequery).'">'.$s1.'</a>';
        }
        if ($s2 = $item[$field2]??'') {
		$basequery['q2']=$s2;
            echo ' <a href="'.DatafeedsModelItems::makeRoute($basequery).'">'.$s2.'</a>';
        }
        if ($s3 = $item[$field3]??'') {
		$basequery['q3']=$s3;
            echo ' <a href="'.DatafeedsModelItems::makeRoute($basequery).'">'.$s3.'</a>';
        }
        echo '</span>
    </div>
    <a class="dflink" href="'.$url.'" rel="nofollow" target="_blank">
        <img loading="lazy"  class="datafeeds_img" src="'. $image.'" alt="'.$alt.'">
    </a>
    <div class="datafeeds_clear datafeeds_fix">&nbsp;</div>
    </div>';
} //foreach
echo '</div>';

if ($this->pagination) {
        echo '<div class="pagination" id="datafeeds_bottom">'.$links.'</div>';
}
echo '</div>';
?>
<style>
div#datafeeds_top,div#datafeeds_bottom{text-align:center;}
div.datafeeds{overflow:hidden;margin:0px 10px;}
p.datafeeds_more{text-align:right;}
div.datafeeds_description{float:right;width:75%;padding-bottom:10px;}
img.datafeeds_img{width:20%;border:0;}
.price{text-align:right;font-size:1.2em;font-weight:bold;}
.datafeeds_clear{clear:both;}
.datafeeds_fix{display:block;height:0;visibility:hidden;}
</style>

